> For the complete documentation index, see [llms.txt](https://docs.warpstream.com/warpstream/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.warpstream.com/warpstream/reference/api-reference/virtual-clusters/updateconfiguration.md).

# UpdateConfiguration

Update the configuration of a specific Virtual Cluster by ID.

## Configuration Options

<table><thead><tr><th width="352">Configuration Name</th><th>Description</th></tr></thead><tbody><tr><td><code>are_acls_enabled</code></td><td>Whether the cluster will enforce Kafka ACLs. Enabling this will block <strong>all</strong> traffic in the cluster if no specific ACLs are configured first.</td></tr><tr><td><code>default_num_partitions</code></td><td>Default number of partitions for topics that are created automatically using Kafka's topic auto-creation feature.</td></tr><tr><td><code>default_retention_millis</code></td><td>Default retention for topics that are created automatically using Kafka's topic auto-creation feature.</td></tr><tr><td><code>is_auto_create_topic_enabled</code></td><td>Whether Kafka's topic auto-creation feature is enabled.</td></tr><tr><td><code>enable_deletion_protection</code></td><td>If <code>true</code>, you will not be able to delete this virtual cluster, the API will refuse it.</td></tr><tr><td><code>default_topic_type</code></td><td>Can be <code>classic</code> or <code>lightning</code> . If <code>lightning</code>, newly created topics will be <a href="/warpstream/kafka/advanced-agent-deployment-options/low-latency-clusters/lightning-topics.md">Lightning Topics</a></td></tr></tbody></table>

## Payload Example

`virtual_cluster_id` is always required, but every field in `virtual_cluster_configuration` is optional. The JSON below shows all possible values that can be modified:

{% code overflow="wrap" %}

```json
{
    "virtual_cluster_id": "vci_1d4980d7_8e6d_4ad9_b27a_656ed4aca3ee",
    "virtual_cluster_configuration": {
        "are_acls_enabled": true,
        "default_num_partitions": 10,
        "is_auto_create_topic_enabled": false,
        "default_retention_millis": 86400000,
        "enable_deletion_protection": true,
        "default_topic_type": "lightning",
    }
}
```

{% endcode %}

However, if you only wanted to change a single value like `default_retention_millis`, then you could construct the request like this:

```json
{
    "virtual_cluster_id": "vci_1d4980d7_8e6d_4ad9_b27a_656ed4aca3ee",
    "virtual_cluster_configuration": {
        "default_retention_millis": 86400000
    }
}
```

Which would modify the value of `default_retention_millis`, but leave all other configuration unchanged.

## Example Request

{% code overflow="wrap" fullWidth="false" %}

```bash
 curl https://api.warpstream.com/api/v1/update_virtual_cluster_configuration \
 -H 'warpstream-api-key: XXXXXXXXXX' \
 -H 'Content-Type: application/json' \
 -d '{"virtual_cluster_id": "vci_1d4980d7_8e6d_4ad9_b27a_656ed4aca3ee", "virtual_cluster_configuration": {"are_acls_enabled": true, "default_num_partitions": 10, "is_auto_create_topic_enabled": false, "default_retention_millis": 86400000}}'
```

{% endcode %}

{% hint style="info" %}
When you select specific configuration fields for updating, only those chosen will be altered. All other fields will remain unchanged.
{% endhint %}

## Response

```json
{}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.warpstream.com/warpstream/reference/api-reference/virtual-clusters/updateconfiguration.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
